/*
 * 16F88_linetrace_r3
 * Cg[X{bg̃eXgpvO (TIMER0荞݂ɂPWM)
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/11/08, 15:05
 */


// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

#include <xc.h>
#include <stdio.h>
#include "uart.h"

#define _XTAL_FREQ 8000000      // 8MHz

#define MOTOR_R RA0     // E[^
#define MOTOR_L RA1     // [^
#define SENSOR_R RA2    // EZT 
#define SENSOR_L RA3    // ZT 
#define LED_R RB1       // LED LowxhCu _
#define LED_L RB0       // LED LowxhCu _

#define RTCC_INTERNAL 0x00      // pX͓NbNg
#define RTCC_DIV_256 0x00       // vXP[̐ݒl: 1/2 (0b000)
#define TMR0_DATA 0x00          // TMR0̏l
#define CNT_DATA 16             // JE^pϐ̏livZ͉Lj
// (1/NbN) * 4 * vXP[ݒl * (255 - (TMR0l - 1))*JE^pϐ̏l : 1ɂ鎞
// (1/8000000*4*2*(255-(0-1)))*16= 0.004096sec :1ɂ鎞

unsigned int cnt; // 荞݊֐ŎgpJEgϐ
unsigned int left_duty; // [^PWMduty 0-16̊Ԃ̒lݒ肷邱
unsigned int right_duty;// E[^PWMduty 0-16̊Ԃ̒lݒ肷邱
unsigned int left_dmy_duty;
unsigned int right_dmy_duty;


// vg^Cv錾
void initTMR0(unsigned char mode);
void setTMR0(unsigned char tmr0);
void interrupt isrTMR0();


void main(void) {
        
    OSCCON = 0b01110000;    // NbN̎g8MHzɐݒ
 
    PORTA = 0x00;           // PORTA
    PORTB = 0x00;           // PORTB
    TRISA = 0b00001100;     // PORTA̓o͐ݒ RA2,3SENSOR
    TRISB = 0b00000100;     // PORTB̓o͐ݒ RB2RX
    ANSEL = 0b00000000;     // ADRo[^
    
    initUART();             // VAʐMݒ
    __delay_ms(100);
    
    cnt = CNT_DATA;             // TMR0݂𗘗p1bJE^pϐ
    initTMR0(RTCC_INTERNAL | RTCC_DIV_256);
    setTMR0(TMR0_DATA);         // TMR0̏lݒ
    TMR0IE = 1;                   // TMR0݂
    GIE = 1;                    // O[o݂
    printf("Line Trace Start!\n");
    
    
    while(1){
        if(SENSOR_R==1){        // ẼZTmꍇ
            printf("Turn right ,");
            LED_R=1; // LEDLowxhCu _
            LED_L=0;
            right_duty=5; // E[^͂]
            left_duty=16; // [^͑S͂ŉ]
        }
        else if(SENSOR_L==1){         // ̃ZTmꍇ
            printf("Turn left  ,");
            LED_R=0;
            LED_L=1;
            right_duty=16; // E[^͑S͂ŉ]
            left_duty=5; // [^͂]
        }
        else{                   // ȊȌꍇ
            printf("Go straight,");
            LED_R=0;
            LED_L=0;
            right_duty=16;
            left_duty=16;
        }
        printf("left_duty:%2d,right_duty:%2d\n",left_duty,right_duty);
    }
}

// ^C}[0荞ݐݒ֐
void initTMR0(unsigned char mode)
{
    OPTION_REG &= 0b11000000; // rbg}XN
    OPTION_REG |= mode; // pX͓orOAvXP[lݒ
    TMR0 = 0x00; // TMR0̃JEgl0ɂ
}
 
// ^C}[0荞ݏlݒ֐
void setTMR0(unsigned char tmr0)
{
    TMR0 = tmr0; // TMR0̏lݒ
}
 
// ^C}[0荞ݔɎs֐
void interrupt isrTMR0() // ISR:Interrupt Service Routine 
{
    TMR0IF = 0;       // TMR0݂NA
    TMR0 = TMR0_DATA; // TMR0JE^JnlăZbg
    cnt--;
    if(left_dmy_duty>cnt){ // [^PWM
        MOTOR_L=1;
    }
    else{
        MOTOR_L=0;
    }
    if(right_dmy_duty>cnt){ // E[^PWM
        MOTOR_R=1;
    }
    else{
        MOTOR_R=0;
    }
    
    if(cnt == 0){
        cnt = CNT_DATA;         // JE^pϐ
        left_dmy_duty=left_duty; // dutyXV
        right_dmy_duty=right_duty;
    }
}
